
void _efl_ui_spin_button_wraparound_set(Eo *obj, Efl_Ui_Spin_Button_Data *pd, Eina_Bool circulate);


static Eina_Error
__eolian_efl_ui_spin_button_wraparound_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_spin_button_wraparound_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_spin_button_wraparound_set, EFL_FUNC_CALL(circulate), Eina_Bool circulate);

Eina_Bool _efl_ui_spin_button_wraparound_get(const Eo *obj, Efl_Ui_Spin_Button_Data *pd);


static Eina_Value
__eolian_efl_ui_spin_button_wraparound_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_spin_button_wraparound_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_spin_button_wraparound_get, Eina_Bool, EINA_FALSE /* false */);

void _efl_ui_spin_button_direct_text_input_set(Eo *obj, Efl_Ui_Spin_Button_Data *pd, Eina_Bool direct_text_input);


static Eina_Error
__eolian_efl_ui_spin_button_direct_text_input_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_ui_spin_button_direct_text_input_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_spin_button_direct_text_input_set, EFL_FUNC_CALL(direct_text_input), Eina_Bool direct_text_input);

Eina_Bool _efl_ui_spin_button_direct_text_input_get(const Eo *obj, Efl_Ui_Spin_Button_Data *pd);


static Eina_Value
__eolian_efl_ui_spin_button_direct_text_input_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_spin_button_direct_text_input_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_spin_button_direct_text_input_get, Eina_Bool, EINA_FALSE /* false */);

Efl_Object *_efl_ui_spin_button_efl_object_constructor(Eo *obj, Efl_Ui_Spin_Button_Data *pd);


Eina_Error _efl_ui_spin_button_efl_ui_widget_theme_apply(Eo *obj, Efl_Ui_Spin_Button_Data *pd);


Eina_Bool _efl_ui_spin_button_efl_ui_widget_widget_input_event_handler(Eo *obj, Efl_Ui_Spin_Button_Data *pd, const Efl_Event *eo_event, Efl_Canvas_Object *source);


Eina_Bool _efl_ui_spin_button_efl_ui_focus_object_on_focus_update(Eo *obj, Efl_Ui_Spin_Button_Data *pd);


void _efl_ui_spin_button_efl_ui_range_display_range_value_set(Eo *obj, Efl_Ui_Spin_Button_Data *pd, double val);


void _efl_ui_spin_button_efl_ui_layout_orientable_orientation_set(Eo *obj, Efl_Ui_Spin_Button_Data *pd, Efl_Ui_Layout_Orientation dir);


Efl_Ui_Layout_Orientation _efl_ui_spin_button_efl_ui_layout_orientable_orientation_get(const Eo *obj, Efl_Ui_Spin_Button_Data *pd);


const char *_efl_ui_spin_button_efl_access_object_i18n_name_get(const Eo *obj, Efl_Ui_Spin_Button_Data *pd);


const Efl_Access_Action_Data *_efl_ui_spin_button_efl_access_widget_action_elm_actions_get(const Eo *obj, Efl_Ui_Spin_Button_Data *pd);


void _efl_ui_spin_button_efl_ui_format_apply_formatted_value(Eo *obj, Efl_Ui_Spin_Button_Data *pd);


void _efl_ui_spin_button_efl_ui_range_interactive_range_step_set(Eo *obj, Efl_Ui_Spin_Button_Data *pd, double step);


double _efl_ui_spin_button_efl_ui_range_interactive_range_step_get(const Eo *obj, Efl_Ui_Spin_Button_Data *pd);


static Eina_Bool
_efl_ui_spin_button_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_SPIN_BUTTON_EXTRA_OPS
#define EFL_UI_SPIN_BUTTON_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_spin_button_wraparound_set, _efl_ui_spin_button_wraparound_set),
      EFL_OBJECT_OP_FUNC(efl_ui_spin_button_wraparound_get, _efl_ui_spin_button_wraparound_get),
      EFL_OBJECT_OP_FUNC(efl_ui_spin_button_direct_text_input_set, _efl_ui_spin_button_direct_text_input_set),
      EFL_OBJECT_OP_FUNC(efl_ui_spin_button_direct_text_input_get, _efl_ui_spin_button_direct_text_input_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_spin_button_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_theme_apply, _efl_ui_spin_button_efl_ui_widget_theme_apply),
      EFL_OBJECT_OP_FUNC(efl_ui_widget_input_event_handler, _efl_ui_spin_button_efl_ui_widget_widget_input_event_handler),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_object_on_focus_update, _efl_ui_spin_button_efl_ui_focus_object_on_focus_update),
      EFL_OBJECT_OP_FUNC(efl_ui_range_value_set, _efl_ui_spin_button_efl_ui_range_display_range_value_set),
      EFL_OBJECT_OP_FUNC(efl_ui_layout_orientation_set, _efl_ui_spin_button_efl_ui_layout_orientable_orientation_set),
      EFL_OBJECT_OP_FUNC(efl_ui_layout_orientation_get, _efl_ui_spin_button_efl_ui_layout_orientable_orientation_get),
      EFL_OBJECT_OP_FUNC(efl_access_object_i18n_name_get, _efl_ui_spin_button_efl_access_object_i18n_name_get),
      EFL_OBJECT_OP_FUNC(efl_access_widget_action_elm_actions_get, _efl_ui_spin_button_efl_access_widget_action_elm_actions_get),
      EFL_OBJECT_OP_FUNC(efl_ui_format_apply_formatted_value, _efl_ui_spin_button_efl_ui_format_apply_formatted_value),
      EFL_OBJECT_OP_FUNC(efl_ui_range_step_set, _efl_ui_spin_button_efl_ui_range_interactive_range_step_set),
      EFL_OBJECT_OP_FUNC(efl_ui_range_step_get, _efl_ui_spin_button_efl_ui_range_interactive_range_step_get),
      EFL_UI_SPIN_BUTTON_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"wraparound", __eolian_efl_ui_spin_button_wraparound_set_reflect, __eolian_efl_ui_spin_button_wraparound_get_reflect},
      {"direct_text_input", __eolian_efl_ui_spin_button_direct_text_input_set_reflect, __eolian_efl_ui_spin_button_direct_text_input_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_spin_button_class_desc = {
   EO_VERSION,
   "Efl.Ui.Spin_Button",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Ui_Spin_Button_Data),
   _efl_ui_spin_button_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_spin_button_class_get, &_efl_ui_spin_button_class_desc, EFL_UI_SPIN_CLASS, EFL_UI_FOCUS_COMPOSITION_MIXIN, EFL_UI_LAYOUT_ORIENTABLE_INTERFACE, EFL_UI_RANGE_INTERACTIVE_INTERFACE, EFL_ACCESS_WIDGET_ACTION_MIXIN, NULL);
